﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.ScopeAssessments
@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}
@*<style>
        .hidden {
            display: none;
        }
    </style>*@
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}
<link href="~/Script/summernote/summernote.css" rel="stylesheet" />
<style>
    .note-toolbar .btn-group, .note-toolbar .btn-group .btn {
        width: inherit !important;
    }

    .adddivProcess {
        padding-left: 20px;
    }
</style>
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
        if ($("#ParentOrgId").val() > 0) {
            $(".titile_heading h1").html("Add Scope Assessment");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
        } else {
            $(".titile_heading h1").html("Scope Assessment");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
    });
</script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Client List</h1>
            <div class="titile_line"></div>
        </div>
        @if (ViewBag.message != null)
        {
            <script>toastr.success('@ViewBag.message')</script>
        }
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form id="form" method="post" asp-area="ApplicationManagement" asp-controller="ScopeAssessment" asp-action="SubmitScopeAssessment"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ScopeAssessment/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.Id)
                            @Html.HiddenFor(m => m.EventType)
                            @Html.HiddenFor(m => m.ParentOrgId)
                            @Html.HiddenFor(m => m.ScopeAssessmentXml)
                            @Html.HiddenFor(m => m.ScopeAssessmentRiskDomainMapXml)
                            @Html.HiddenFor(m => m.ScopeAssessmentISOMapXml)
                            @Html.HiddenFor(m => m.ScopeAssessmentRegulationMapXml)
                            <div class="pb-3" id="formAssessment">
                                <div id="Paris" class="tabcontent">
                                    <div class="pb-2 mt-4 mb-2 border-bottom box_title" id="divAssessment">Scope of Assessment</div>
                                    <div class="row">
                                        <div class="col-md-4 col-sm-6 col-xs-12">
                                            <label>Child Client</label>
                                            <div class="select_box m_bottom">
                                                @Html.DropDownListFor(m => m.ChildOrgId, Model.DDlOrganizationChild, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation(this)" })
                                            </div>
                                        </div>
                                        <div class="col-md-4 col-sm-6 col-xs-12">
                                            <label>Risk Domain</label>
                                            <div class="select_box m_bottom">
                                                @Html.DropDownListFor(m => m.RiskDomainId, Model.DdlRiskDomain, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation(this)" })
                                            </div>
                                        </div>
                                        <div class="col-md-4 col-sm-6 col-xs-12">
                                            <label>Standards and Framework</label>
                                            <div class="select_box m_bottom">
                                                @Html.DropDownListFor(m => m.ISOId, Model.DdlInternational, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation(this)" })
                                            </div>
                                        </div>
                                    </div>
                                    <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                        Regulation
                                    </div>
                                    <div class="row">
                                        <div class="col-md-4 col-sm-6 col-xs-12">
                                            <label>Country</label>
                                            <div class="select_box m_bottom">
                                                @Html.DropDownList("CountryId", Model.DdlCountry, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation(this)" })
                                            </div>
                                            <label>Sector</label>
                                            <div class="select_box m_bottom">
                                                @Html.DropDownList("SectorId", Model.DdlSector, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation(this)" })
                                            </div>
                                        </div>
                                        <div class="col-md-8 col-sm-6 col-xs-12">
                                            <div class="table_control">
                                                <table id="MixRegulation" class="table">
                                                    <thead>
                                                        <tr>
                                                            <th>Select</th>
                                                            <th>SNo</th>
                                                            <th>Country</th>
                                                            <th>Sector</th>
                                                            <th>Regulation</th>
                                                            <th>RequirementId</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody></tbody>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!--Threats identified-->
                            @*<div class="pb-3 hidden" id="formThreats">
                                    <div id="Paris" class="tabcontent">
                                        <div class="pb-2 mt-4 mb-2 border-bottom box_title" id="divThreats">Threats Identified</div>
                                        <div class="row">
                                            <input type="hidden" asp-for="Probability" />
                                            <input type="hidden" asp-for="uniqueId" />
                                            <input type="hidden" asp-for="ParentOrgName" />
                                            <input type="hidden" asp-for="ChildOrgName" />
                                            <input type="hidden" asp-for="ChildOrgLocation" />
                                            <div class="col-md-4 col-sm-6 col-xs-12">
                                                <label>Threats identified</label>
                                                <div class="select_box m_bottom">
                                                     <select asp-for="ThreatId" asp-items="Model.DdlThreat" class="form-control multiple" multiple="multiple">
                                                     </select>
                                                </div>
                                            </div>
                                            <div class="col-md-4 col-sm-6 col-xs-12">
                                                <label></label>
                                                <div class="select_box m_bottom">
                                                    <button type="button" class="btn btn-primary" onclick="ThreatsSave()"><i class="fa fa-plus"></i>Save</button>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <table id="tbl" class="table">
                                                <tr>
                                                    <th>Threats Identified</th>
                                                    <th>
                                                        Probability(Client Centre)
                                                    </th>
                                                </tr>
                                            </table>
                                        </div>
                                    </div>
                                </div>*@
                            <!--Threats end-->
                            <script>
                                function PrepareXML() {
                                    var ScopeAssessmentXml = [], ScopeAssessmentRiskDomainMapXml = [], ScopeAssessmentISOMapXml = [], ScopeAssessmentRegulationMapXml = [];
                                    var ichild = 0, iRisk = 0, iISO = 0;
                                    $('#ChildOrgId option:selected').each(function (i) {
                                        var childOrgId = $(this).val();
                                        if (childOrgId == 'multiselect-all') {
                                            return;
                                        } else {
                                            ScopeAssessmentXml[ichild] = {
                                                ChildOrgId: parseInt(childOrgId)
                                            }
                                            ichild++;
                                        }
                                    });
                                    $('#ScopeAssessmentXml').val(JSON.stringify(ScopeAssessmentXml));

                                    $('#RiskDomainId option:selected').each(function (i) {
                                        var riskDomainId = $(this).val();
                                        if (riskDomainId == 'multiselect-all') {
                                            return;
                                        } else {
                                            ScopeAssessmentRiskDomainMapXml[iRisk] = {
                                                RiskDomainId: parseInt(riskDomainId)
                                            }
                                            iRisk++;
                                        }
                                    });
                                    $('#ScopeAssessmentRiskDomainMapXml').val(JSON.stringify(ScopeAssessmentRiskDomainMapXml));

                                    $('#ISOId option:selected').each(function (i) {
                                        var iSOId = $(this).val();
                                        if (iSOId == 'multiselect-all') {
                                            return;
                                        } else {
                                            ScopeAssessmentISOMapXml[iISO] = {
                                                ISOId: parseInt(iSOId)
                                            }
                                            iISO++;
                                        }
                                    });
                                    $('#ScopeAssessmentISOMapXml').val(JSON.stringify(ScopeAssessmentISOMapXml));

                                    $('.RegulationId:checked').each(function (i) {
                                        ScopeAssessmentRegulationMapXml[i] = {
                                            RegulationId: parseInt($(this).attr("value"))
                                        }
                                    });
                                    $('#ScopeAssessmentRegulationMapXml').val(JSON.stringify(ScopeAssessmentRegulationMapXml));

                                    $('form').submit();
                                }
                                function getUnique(array) {
                                    var uniqueArray = [];

                                    /*CorporateOffiCCorporateOfficeLocationCorporateOfficeLocationCorporateOfficeLocationorporateOfficeLocationcCorporateOfficeLocationeLocation*/                          // Loop through array values
                                    for (i = 0; i < array.length; i++) {
                                        if (uniqueArray.indexOf(array[i]) === -1) {
                                            uniqueArray.push(array[i]);
                                        }
                                    }
                                    return uniqueArray;
                                }
                                $("input[name=ChildOrgName]").keyup(function (e) {
                                    $.ajax({
                                        url: "/ApplicationManagement/Organogram/CheckOrgName",
                                        type: "POST",
                                        cache: false,
                                        data: { ChildOrgName: e.target.value },
                                        success: function (result) {
                                        },
                                        error: function (ex) {
                                            console.log(ex.responseText);
                                        }
                                    });
                                });
                                function ThreatsSave() {
                                    var arr = $("label[for=t_tooltip]").text();
                                    var ar = arr.slice($("#labelParentOrg").text().length);
                                    var out = ar.split(",");
                                    $("input[name=ChildOrgName]").val(out[0]);
                                    $("input[name=ChildOrgLocation]").val(out[1]);
                                    var types = [];
                                    $('tr').each(function () {
                                        //find the combat elements in the current row and sum it
                                        $(this).find('input').each(function (i) {
                                            if (i % 2 == 0) {
                                                types.push({
                                                    uniqueId: parseInt($(this).val())
                                                });
                                            } else {
                                                types.push({ Probability: parseInt($(this).val()) });
                                            }
                                        });
                                    });
                                    //types.splice(0, 1);

                                    $("input[name=Probability]").val(JSON.stringify(types));
                                    //$("input[name=uniqueId]").val(JSON.stringify(arr));
                                    $("input[name=ParentOrgName]").val($("#labelParentOrg").text());
                                    if ($('select[name=ThreatId] option:selected').val() == undefined && TextVal["length"] == 0) {
                                        toastr.error("Please a select threat identified");
                                    } else if ($("input[name=Probability]").val() == "") {
                                        toastr.error("please add probability");
                                    } else {
                                        $.ajax({
                                            url: "/ApplicationManagement/Organogram/SaveThreatIdentified",
                                            type: "POST",
                                            cache: false,
                                            data: { ParentOrgName: $("input[name=ParentOrgName]").val(), ChildOrgName: $("input[name=ChildOrgName]").val(), ChildOrgLocation: $("input[name=ChildOrgLocation]").val(), uniqueId: $("input[name=uniqueId]").val(), Probability: $("input[name=Probability]").val() },
                                            success: function (res) {
                                                $("input[name=Probability]").val("");
                                                toastr.success("Save Probability successfully");
                                            }, error: function (ex) {
                                                console.log(ex.responseText);
                                            }
                                        });
                                    }
                                }
                                var childId = 0;
                                function XML() {
                                    debugger;
                                    var FunctionProcessXML = [], ChildOrgXML = [];
                                    $('.functions').each(function (i, ele) {
                                        var functionName = $(ele).children('div').eq(0).children('div').eq(0).find('input').val();
                                        var processArray = [];
                                        $(ele).find('.divProcess').each(function (iProc, eleProc) {
                                            var Identified = $(eleProc).find('[name="Identified"]').val();
                                            var Owner = $(eleProc).find('[name="UserId"]').val();
                                            var Description = $(eleProc).find('[name="Description"]').val();
                                            //alert(Identified + ' - ' + Owners + '  - ' + textarea);
                                            processArray[iProc] = {
                                                ProcessIdentified: Identified,
                                                FunctionalOwner: Owner,
                                                Description: Description
                                            }
                                        });
                                        FunctionProcessXML[i] = {
                                            FunctionName: functionName,
                                            Processses: processArray
                                        }
                                    });
                                    $('#FunctionProcessXML').val(JSON.stringify(FunctionProcessXML));

                                    $('#multiChildOrgDiv .row').each(function (i, ele) {
                                        var name = $(ele).find('[name="name"]').val();
                                        var location = $(ele).find('[name="location"]').val();
                                        ChildOrgXML[i] = {
                                            ChildOrgName: name,
                                            ChildOrgLocation: location
                                        }
                                    });
                                    $('#ChildOrgXML').val(JSON.stringify(ChildOrgXML));
                                    $('#formFunctionProcessChild').submit();
                                }
                                function SaveFunction() {
                                    debugger;
                                    var FunctionProcessXML = [];
                                    $('.functions').each(function (i, ele) {
                                        var functionName = $(ele).children('div').eq(0).children('div').eq(0).find('input').val();

                                        var processArray = [];
                                        $(ele).find('.adddivProcess').each(function (iProc, eleProc) {
                                            var Identified = $(eleProc).find('[name="Identified"]').val();
                                            var Owner = $(eleProc).find('[name="UserId"]').val();
                                            var Description = $(eleProc).find('[name="Description"]').val();//$(eleProc).find('[name="Description"]').summernote('code');//$(eleProc).find('[name="Description"]').val();
                                            //alert(Identified + ' - ' + Owners + '  - ' + textarea);
                                            processArray[iProc] = {
                                                ProcessIdentified: Identified,
                                                FunctionalOwner: Owner,
                                                Description: Description
                                            }
                                        });
                                        FunctionProcessXML[i] = {
                                            FunctionName: functionName,
                                            Processses: processArray
                                        }
                                    });
                                    //$('#FunctionProcessXML').val(JSON.stringify(FunctionProcessXML));

                                    var model = {
                                        OrganizationId: parseInt($('#ParentOrg').val()),
                                        ChildOrgId: childId,
                                        FunctionProcessXML: JSON.stringify(FunctionProcessXML)
                                    }

                                    $.post('/ApplicationManagement/Organogram/SubmitFunctionProcess', { model: model }, function (res) {
                                        if (res.isSuccess) {
                                            $('a[href="/ApplicationManagement/Organogram/Index"]').click();
                                            toastr.success('Questionnaire saved successfully.');
                                        } else {
                                            toastr.error('Something went wrong!');
                                        }
                                        $('#preloader').hide();
                                    });
                                }
                                function ShowFunctionsProcessesForm(input, lbl1, lbl2, ID) {
                                    debugger
                                    $("#formThreats").addClass("hidden");
                                    $('#preloader').show();
                                    $('#formFunctionsProcesses').attr('hidden', 'hidden');
                                    setTimeout(function () {
                                        $('#formFunctionsProcesses').removeAttr('hidden');
                                        $('#preloader').hide();
                                    }, 1000);
                                    $('#formEnablers').attr('hidden', 'hidden');
                                    $('#formAssessment').attr('hidden', 'hidden');
                                    $('#ParentOrg').val(ID);
                                    $('#divFunctionsProcesses').text('Functions and Processes for ' + lbl1 + " ," + lbl2);
                                }

                                function ShowEnablersForm(lbl1, lbl2, childOrgId) {
                                    $('#preloader').show();
                                    $('#formEnablers').attr('hidden', 'hidden');
                                    setTimeout(function () {
                                        $('#formEnablers').removeAttr('hidden');
                                        $('#preloader').hide();
                                    }, 1000);
                                    $('#formAssessment').attr('hidden', 'hidden');
                                    $('#formFunctionsProcesses').attr('hidden', 'hidden');
                                    $('#divEnablers').text('Enablers for ' + lbl1 + lbl2);
                                    childId = childOrgId;
                                }
                                function ShowAssessmentForm(lbl1, lbl2) {
                                    $("#formThreats").addClass("hidden");
                                    $('#preloader').show();
                                    $('#formAssessment').attr('hidden', 'hidden');
                                    setTimeout(function () {
                                        $('#formAssessment').removeAttr('hidden');
                                        $('#preloader').hide();
                                    }, 1000);
                                    $('#formEnablers').attr('hidden', 'hidden');
                                    $('#formFunctionsProcesses').attr('hidden', 'hidden');
                                    $('#divAssessment').text('Scope of Assessment for ' + lbl1 + lbl2);
                                }
                                function ShowThreatsForm(lbl1, lbl2) {
                                    $.ajax({
                                        url: "/ApplicationManagement/Organogram/CheckThreatById",
                                        type: "POST",
                                        cache: false,
                                        data: { OrgName: lbl1, ChildOrgName: lbl2 },
                                        success: function (list) {
                                            debugger;
                                        },
                                        error: function (ex) { console.log(ex.responseText) }
                                    });
                                    $("#formThreats").removeClass("hidden");
                                    $('#formAssessment').attr('hidden', 'hidden');
                                    $('#formEnablers').attr('hidden', 'hidden');
                                    $('#formFunctionsProcesses').attr('hidden', 'hidden');
                                }
                                function AddMoreChildOrganizationRow() {
                                    var inputHTML = $('#multiChildOrgDiv div:first').html();
                                    var html = '<div class="row">' + inputHTML + '</div>';
                                    $('#multiChildOrgDiv').append(html);
                                    $('#multiChildOrgDiv div:last').find('label').attr('class', 'remvbtn').attr('onclick', 'RemoveRow(this)');
                                }
                                function AddMoreFunctionRow() {
                                    var processHTML = $('.divProcess').eq(0).html();
                                    var functionHTML = '<div class="function_div functions"><div class="row">' +
                                        '<div class="col-6 multiProcessDiv"><div class="row">' +
                                        '<div class="col-7"><label>Function Name</label>' +
                                        '<div class="select_box m_bottom">' +
                                        '<input type="text" class="form-control" />' +
                                        '</div></div><div class="col-2"><label class="remvbtn" onclick="RemoveFunctionRow(this)" style="cursor:pointer"></label></div></div></div>' +
                                        '<div class="col-12 divProcess">' + processHTML + '</div>' +
                                        //'</div>' +
                                        '</div></div>';
                                    $('#multiFunctionDiv').append(functionHTML);
                                    $('.functions:last div:first div:last').find('label').attr('onclick', 'AddMoreProcessRow(this)');
                                }
                                function AddMoreProcessRow(btn) {
                                    debugger;

                                    var text = '<div class="adddivProcess">' +
                                        '<div class="row" >' +
                                        '<div class="col-3">' +
                                        '<label>Process Name</label>' +
                                        '<div class="select_box m_bottom">' +
                                        '<input type="text" class="form-control m_no" name="Identified" placeholder="Enter process">' +
                                        '</div>' +
                                        '</div>' +
                                        '<div class="col-3">' +
                                        '<label>Process Owners</label>' +
                                        '<div class="select_box m_bottom">' +
                                        '<select id="UserId" class="validate[] text-input form-control ddlUserdata"> "' + $('.ddlUserdata').html() + '"</select>' +
                                        '</div>' +
                                        '</div> ' +
                                        '<div class="col-5">' +
                                        '<label>Process Description</label>' +
                                        '<textarea class="form-control m_no textarea" name="Description"></textarea>' +
                                        '</div>' +
                                        "<div class='col-1'>" +
                                        "<label class='remvbtn' onclick='RemoveProcessRow(this)' style='cursor:pointer'></label>" +
                                        "</div>";

                                    //  var processHTML = $('.divProcess').eq(0).html();
                                    /// var html = '<div class="row divProcess">' + processHTML + '</div>';

                                    //  $(btn).closest('.multiProcessDiv').append(html);
                                    $('.divProcess').append(text);
                                    //$(btn).closest('.multiProcessDiv').find('div:last').find('label').attr('class', 'remvbtn').attr('onclick', 'RemoveProcessRow(this)');
                                }
                                function RemoveFunctionRow(ele) {
                                    $(ele).parent('div:eq(0)').closest('.functions').remove();
                                }
                                function RemoveProcessRow(ele) {
                                    $(ele).parent('div:eq(0)').closest('.row').remove();
                                }
                                function fn_GetQuestionnaire(select) {
                                    $('#preloader').show();
                                    $("#dvmultiTable").empty();
                                    $('#CategoryId option:selected').each(function (i) {
                                        var CategoryId = $(this).val();
                                        var CategoryText = $(this).text();
                                        if (CategoryId == 'multiselect-all') {
                                            $("#dvmultiTable").empty();
                                            return;
                                        }
                                        var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
                                        $.get('/ApplicationManagement/Compliance/GetQuestionnaireById', { CategoryId: CategoryId }, function (data) {
                                            html += '<th colspan="' + parseInt(data.length + 2) + '">' + CategoryText + '</th></tr>';
                                            html += '<tr><th name="0">SN</th>';
                                            $.each(data, function (i, value) {
                                                html += '<th name=' + value.id + '>' + value.query + '</th>';
                                            });
                                            html += '<th name="0">Action</th></tr></thead><tbody><tr><td>1</td>';
                                            $.each(data, function (i, value) {
                                                html += '<td><input type="text" class="form-control ques' + value.id + '" /></td>';
                                            });
                                            html += '<td><input type="button" class="btn btn-info" value="Add" onclick="AddMoreAnswers(this)"/></td></tr></tbody></table>';
                                            $("#dvmultiTable").append(html);
                                            $('#preloader').hide();
                                        });
                                    });
                                }
                                function AddMoreAnswers(input) {
                                    var tdLength = $(input).closest('tr').find('td').length;
                                    var sn = parseInt($(input).closest('tbody').find('tr:last td:eq(0)').text()) + 1;
                                    var html = '<tr><td>' + sn + '</td>';
                                    for (var i = 0; i < tdLength; i++) {
                                        if (i == 0 || i == tdLength - 1) { continue; }
                                        html += '<td>';
                                        html += $(input).closest('tbody').find('tr:first td').eq(i).html();
                                        html += '</td>';
                                    }
                                    html += '<td><input type="button" class="btn btn-danger" value="Remove" onclick="RemoveMoreAnswers(this)"></td></tr>';
                                    $(input).closest('tbody').append(html);
                                }
                                function RemoveMoreAnswers(input) {
                                    $(input).closest('tr').remove();
                                }
                                function SaveQuestionnaire() {
                                    $('#preloader').show();
                                    var QuestionnaireXML = [];
                                    $('#dvmultiTable table').each(function (i, table) {
                                        var CategoryId = parseInt($(table).attr('id').split('_')[1]);
                                        var QuesArray = [], iQues = 0;
                                        $(table).find('thead tr:eq(1) th').each(function (i, th) {
                                            var quesId = parseInt($(th).attr('name'));
                                            if (quesId == 0) { return; }
                                            var AnsArray = [];
                                            $('.ques' + quesId).each(function (i, input) {
                                                AnsArray[i] = {
                                                    Answer: $(input).val()
                                                }
                                            });
                                            QuesArray[iQues] = {
                                                QuestionId: quesId,
                                                AnsArray: AnsArray
                                            }
                                            iQues++;
                                        });
                                        QuestionnaireXML[i] = {
                                            CategoryId: CategoryId,
                                            QuesArray: QuesArray
                                        }
                                    });
                                    var model = {
                                        OrganizationId: parseInt($('#ParentOrg').val()),
                                        ChildOrgId: childId,
                                        QuestionnaireXML: JSON.stringify(QuestionnaireXML)
                                    }
                                    debugger;
                                    $.post('/ApplicationManagement/Assesment/SaveAssesment', { model: model }, function (res) {
                                        if (res.isSuccess) {
                                            $('a[href="/ApplicationManagement/Organogram/Index"]').click();
                                            toastr.success('Questionnaire saved successfully.');
                                        } else {
                                            toastr.error('Something went wrong!');
                                        }
                                        $('#preloader').hide();
                                    });
                                }
                                $(".multiselect-all").change(function () {
                                    var text = [];
                                    $("#tbl").find('tr:gt(0)').remove();
                                    var check = $('input[type=checkbox]:checked').length - 2;
                                    $("select[name=ThreatId] :selected").each(function (i, sel) {
                                        text.push($(sel).text());
                                        TextVal.push($(sel).val());
                                    });
                                    var uniqe = getUnique(TextVal);
                                    uniqe = uniqe.sort(function (a, b) {
                                        return a - b;
                                    });
                                    text.splice(0, 1);
                                    for (var i = 0; i < check; i++) {
                                        $("#tbl").append('<tr><td><input type="hidden" name="probVal" value="' + uniqe[i] + '"/><label>' + text[i] + '</label></td><td><div class="select_box m_bottom"><input name="Probability" class="form-control" placeholder="Enter probability" /></div></td></tr>');
                                    }
                                });
                                var TextVal = [];
                                TextVal.length = 0;
                                $("select[name=ThreatId]").change(function (e) {
                                    var text = [];
                                    $("#tbl").find('tr:gt(0)').remove();
                                    var check = $('input[type=checkbox]:checked').length - 1;
                                    $("select[name=ThreatId] :selected").each(function (i, sel) {
                                        text.push($(sel).text());
                                        TextVal.push($(sel).val());
                                    });
                                    var uniqe = getUnique(TextVal);
                                    uniqe = uniqe.sort(function (a, b) {
                                        return a - b;
                                    });
                                    for (var i = 0; i < check; i++) {
                                        $("#tbl").append('<tr><td><input type="hidden" name="probVal" value="' + uniqe[i] + '"/><label>' + text[i] + '</label></td><td><div class="select_box m_bottom"><input name="Probability" class="form-control" placeholder="Enter probability" /></div></td></tr>');
                                    }

                                });
                            </script>
                            <div class="row pt-3">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                        </div>
                                    </div>
                                    <div class="submitbtn">
                                        <input type="button" value="Submit" onclick="PrepareXML()">
                                        @*<input type="button" value="Submit" onclick="XML()">*@
                                        <input type="reset" id="reset" value="reset" hidden />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Parent Organization Name</th>
                                                <th>Corporate Office Location</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.OrganizationsList)
                                            {
                                                <tr>
                                                    <td>@(++sn)</td>
                                                    <td>@item.ParentOrgName</td>
                                                    <td>@item.CorporateOfficeLocation</td>
                                                    <td>
                                                        <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-OrganizationId="@item.Id" asp-controller="ScopeAssessment" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                        @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                        @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                    <script>
                                        function OpenForm(Id, ParentOrgName, CorporateOfficeLocation) {
                                            $('#dvDataTable').hide();
                                            $('#dvForm').removeAttr('class');
                                            $('#labelParentOrg').text(ParentOrgName);
                                            $('#spanParentOrg').attr('onclick', 'fireTip(this,"' + ParentOrgName + '", "","' + Id + '")');
                                            $('#ParentOrg').val(Id);
                                        }
                                    </script>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script type="text/javascript">

    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
        $('#btnBasic').trigger('click');
    }
    function hideForm() {
        $('#reset').click();
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
        $('#btnBasic').trigger('click');
    }
    function fnSetMultiselectValue() {
        var SectorIds = [], CountryIds = [], ComplianceIds = [];
        $('.SectorIds option:selected').each(function (i) {
            if ($(this).val() == 0) {
                return;
            }
            SectorIds.push($(this).val());
        });
        $('#SectorIds').val(JSON.stringify(SectorIds));

        $('.CountryIds option:selected').each(function (i) {
            if ($(this).val() == 0) {
                return;
            }
            CountryIds.push($(this).val());
        });
        $('#CountryIds').val(JSON.stringify(CountryIds));

        $('.ComplianceIds:checked').each(function (i) {
            ComplianceIds.push($(this).attr("value"));
        });
        $('#ComplianceIds').val(JSON.stringify(ComplianceIds));

        var QuestionnaireXML = [];
        $('#dvmultiTable table').each(function (i, table) {
            var CategoryId = parseInt($(table).attr('id').split('_')[1]);
            var QuesArray = [], iQues = 0;
            $(table).find('thead tr:eq(1) th').each(function (i, th) {
                var quesId = parseInt($(th).attr('name'));
                if (quesId == 0) { return; }
                var AnsArray = [];
                $('.ques' + quesId).each(function (i, input) {
                    AnsArray[i] = {
                        Answer: $(input).val()
                    }
                });
                QuesArray[iQues] = {
                    QuestionId: quesId,
                    AnsArray: AnsArray
                }
                iQues++;
            });
            QuestionnaireXML[i] = {
                CategoryId: CategoryId,
                QuesArray: QuesArray
            }
        });
        $('#QuestionnaireXML').val(JSON.stringify(QuestionnaireXML));
        console.log(QuestionnaireXML);
    }
    function fnUpdate(Id, ParentOrgName, CorporateOfficeLocation, ChildOrgName, ChildOrgLocation, SectorIds, CountryIds, ComplianceIds) {
        showForm()
        $('#Id').val(Id);
        $('#ParentOrgName').val(ParentOrgName);
        $('#CorporateOfficeLocation').val(CorporateOfficeLocation);
        $('#ChildOrgName').val(ChildOrgName);
        $('#ChildOrgLocation').val(ChildOrgLocation);
        $('#EventType').val(1);
        var SectorArray = JSON.parse(SectorIds);
        $.each(SectorArray, function (i, data) {
            $('#SectorId_' + data).prop('selected', 'selected');
        });
        var CountryArray = JSON.parse(CountryIds);
        $.each(CountryArray, function (i, data) {
            $('#CountryId_' + data).prop('selected', 'selected');
        });
        var ComplianceArray = JSON.parse(ComplianceIds);
        $.each(ComplianceArray, function (i, data) {
            $('#ComplianceId_' + data).prop('checked', 'checked');
        });
    }
    function fnBlockDelete(Id, Action, Type) {
        if (confirm('Are you sure you want to ' + Action + ' this?')) {
            $.get('/ApplicationManagement/Organization/BlockDeleteOrganization', { Id: Id, EventType: Type }, function (data) {
                if (data.code == 200) {
                    toastr.success(Action + ' successfully');
                    $('a[href="/ApplicationManagement/Organization/Index"]').click();
                } else {
                    toastr.error('Something went wrong!');
                }
            });
        }
    }
    function fn_GetRegulation() {
        if ($("#SectorId").val() != null && $("#CountryId").val() != null) {
            $("#MixRegulation tbody").empty();
            // $("#MixRegulation ul").append($("<option></option>").val(0).html("Select"));
            $('#preloader').show();
            $.ajax({
                type: "GET",
                url: "/Master/Regulation/GetSectorCountryWiseRegulation",
                data: jQuery.param({ SectorId: $("#SectorId").val().toString().replace("multiselect-all", ""), CountryId: $("#CountryId").val().toString().replace("multiselect-all", "") }),
                dataType: "json",
                contentType: "application/json",
                success: function (res) {
                    $('#preloader').hide();
                    $.each(res, function (data, value) {
                        //  $("#MixRegulation").append($("<li></li>").id(value.id).html(value.title));
                        $("#MixRegulation tbody").append(
                            "<tr>" +
                            "<td>" + "<input type='checkbox' class='RegulationId' value=" + value.regoId + "/>" + "</td>" +
                            "<td>" + (data + 1) + "</td>" +
                            "<td>" + value.countryName + "</td>" +
                            "<td>" + value.sectorName + "</td>" +
                            "<td>" + value.regulationName + "</td>" +
                            "<td>" + value.requirement_ID + "</td>" +
                            "</tr>"
                        );
                    });
                }
            });
        }
    }
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this organization',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Organization/BlockDeleteOrganization",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/ApplicationManagement/Organization/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this organization',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $.ajax({
                    url: "/ApplicationManagement/Organization/BlockDeleteOrganization",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 0 },
                    success: function (result) {
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/ApplicationManagement/Organization/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>
<script src="~/Script/summernote/summernote.js"></script>
<script src="~/Script/Master/Layout.js"></script>
<script>
    $('.textarea').summernote({
        placeholder: 'Write About Process Description',
        tabsize: 1,
        height: 100,
        toolbar: [
            //['style', ['style']],
            ['font', ['bold', 'underline', 'clear']],
            //['color', ['color']],
            ['para', ['ul', 'ol', 'paragraph']],
            //['table', ['table']],
            //['insert', ['link', 'picture', 'video']],
            //['view', ['fullscreen', 'codeview', 'help']]
        ]
    });

    //$('.textarea').summernote({
    //    height: 100, //set editor height
    //    minHeight: null, //set minimum height of editor
    //    maxHeight: null, //set maximum height of editor
    //    toolbar: false,
    //    // focus: true,
    //    //toolbar: [
    //    //    // [groupName, [list of button]]
    //    //    ['style', ['bold', 'italic', 'underline', 'clear']],
    //    //    ['font', ['strikethrough', 'superscript', 'subscript']],
    //    //    ['fontsize', ['fontsize']],
    //    //    ['color', ['color']],
    //    //    ['para', ['ul', 'ol', 'paragraph']],
    //    //    ['height', ['height']]
    //    //] //set focus to editable area after initializing summernote //set focus to editable area after initializing summernote
    //});
</script>

